/**
  * JASS Project. WS-CAF.
  *
  * Copyright (c) 2006, Distributed Systems Lab, Universidad Politecnica 
  * de Madrid (Spain)
  * All rights reserved.
  * Contact:
  *        web page: http://lsd.ls.fi.upm.es/lsd
  *        e-mail: mpatino@fi.upm.es or rjimenez@fi.upm.es
  *
  * Redistribution and use in source and binary forms, with or without 
  * modification, are permitted provided that the following conditions are met:
  *
  *    - Redistributions of source code must retain the above copyright 
  *      notice, this list of conditions and the following disclaimer.
  *    - Redistributions in binary form must reproduce the above copyright 
  *      notice, this list of conditions and the following disclaimer in the 
  *      documentation and/or other materials provided with the distribution.
  *    - Neither the name of the Distributed Systems Lab nor the names of 
  *      its contributors may be used to endorse or promote products derived from 
  *      this software without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
  * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
  * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
  * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
  * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, *
  * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
  * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
  * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  * 
  * Contributors: 
  * Francisco Pérez-Sorrosal (fpsorrosal@zipi.fi.upm.es)
  * Rubén Naranjo Izquierdo (rnaranjo@alumnos.upm.es)
  * José Antonio Sánchez Murillo (jsanchez@alumnos.upm.es)
  * 
  **/

package org.oasis.wscaf.module.utils;

import javax.xml.namespace.QName;

public class ContextModuleConstants {
	
	
	public static String CONTEXT_BINDING_PACKAGE = "org.oasis.wscaf.bindings.wsctx";
	public static String COORDINATION_BINDING_PACKAGE = "org.oasis.wscaf.bindings.wscf";
	public static String LRA_BINDING_PACKAGE = "org.oasis.wscaf.bindings.lra";
	public static String REFERENCE_BINDING_PACKAGE = "org.oasis.wscaf.bindings.reference";
	public static String SECURITY_BINDING_PACKAGE = "org.oasis.wscaf.bindings.security";
	
	public static String CONTEXT_NS      = "http://docs.oasis-open.org/ws-caf/2005/10/wsctx";
	public static String COORDINATION_NS = "http://docs.oasis-open.org/wscaf/2005/10/wscf";
	public static String LRA_NS          = "http://www.webservicestransactions.org/schemas/wstxm/tx-lra/2003/03";
	public static String LRA_WSDL_NS	= "http://www.webservicestransactions.org/wsdl/wstxn/tx-lra/2003/03";
	
	public static QName CONTEXT_NAME = new QName(CONTEXT_NS,"context");
	public static QName REGISTRATION_CONTEXT_NAME = new QName(COORDINATION_NS,"registrationContext");
	public static QName LRA_CONTEXT_NAME = new QName(LRA_NS,"lraContext");
	
	public static String CurrentContextProperty = "org.oasis.wscaf.CurrentContext";
	public static String CurrentRegistrationContextProperty = "org.oasis.wscaf.CurrentRegistrationContext";
	public static String CurrentLRAContextProperty = "org.oasis.wscaf.CurrentLRAContext";
	
	public static String OutContextProperty = "org.oasis.wscaf.OutContext";
	public static String OutRegistrationContextProperty = "org.oasis.wscaf.OutRegistrationContext";
	public static String OutLRAContextProperty = "org.oasis.wscaf.OutLraContext";

	public static String COMPENSATE_NAME = ContextModuleConstants.LRA_WSDL_NS+"/compensate";
	public static String COMPLETE_NAME = ContextModuleConstants.LRA_WSDL_NS+"/complete";
	public static String FORGET_NAME = ContextModuleConstants.LRA_WSDL_NS+"/forget";
	
	public static QName PARTICIPANT_KEY_NAME = new QName(LRA_NS,"ParticipantKey");
	public static String COMPENSATOR_HANDLER_PARAMETER_NAME = "org.oasis.wscaf.compensatorHandler";
	
	public static String CONTEXT_SERVICE_LOCATION_PARAMETER_NAME = "ContextServiceLocation";
	public static String CONTEXT_MANAGER_LOCATION_PARAMETER_NAME = "ContextManagerLocation";
	public static String REGISTRATION_SERVICE_LOCATION_PARAMETER_NAME = "RegistrationServiceLocation";
	
	public static String CafInfoProperty = "org.oasis.wscaf.WSCAFInfo";
}
