/**
  * JASS Project. WS-CAF.
  *
  * Copyright (c) 2006, Distributed Systems Lab, Universidad Politecnica 
  * de Madrid (Spain)
  * All rights reserved.
  * Contact:
  *        web page: http://lsd.ls.fi.upm.es/lsd
  *        e-mail: mpatino@fi.upm.es or rjimenez@fi.upm.es
  *
  * Redistribution and use in source and binary forms, with or without 
  * modification, are permitted provided that the following conditions are met:
  *
  *    - Redistributions of source code must retain the above copyright 
  *      notice, this list of conditions and the following disclaimer.
  *    - Redistributions in binary form must reproduce the above copyright 
  *      notice, this list of conditions and the following disclaimer in the 
  *      documentation and/or other materials provided with the distribution.
  *    - Neither the name of the Distributed Systems Lab nor the names of 
  *      its contributors may be used to endorse or promote products derived from 
  *      this software without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
  * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
  * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
  * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
  * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, *
  * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
  * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
  * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  * 
  * Contributors: 
  * Francisco Pérez-Sorrosal (fpsorrosal@zipi.fi.upm.es)
  * Rubén Naranjo Izquierdo (rnaranjo@alumnos.upm.es)
  * José Antonio Sánchez Murillo (jsanchez@alumnos.upm.es)
  * 
  **/

package org.oasis.wscaf.module.utils;

import javax.xml.namespace.QName;

import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.impl.llom.factory.OMLinkedListImplFactory;
import org.apache.axis2.addressing.AddressingConstants;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.axis2.addressing.EndpointReferenceHelper;
import org.apache.axis2.util.XMLUtils;
import org.oasis.wscaf.bindings.reference.ObjectFactory;
import org.oasis.wscaf.bindings.reference.ServiceRefType;
import org.w3c.dom.Element;

public class DatabindingHelper {

	public static EndpointReference serviceRefToEpr(ServiceRefType serviceRef) throws Exception {
		EndpointReference res = null;
		if (serviceRef != null) {
			Element eprNode = (Element) serviceRef.getAny();
			if (eprNode != null) {
				OMElement omRef = XMLUtils.toOM(eprNode);
				res = EndpointReferenceHelper.fromOM(omRef);
			}
		}
		return res;
	}
	
	public static ServiceRefType eprToServiceRef(EndpointReference epr, String addressingSpec) throws Exception {
		ServiceRefType res = null;
		if ((epr != null)) {
			String add = (addressingSpec == null)?AddressingConstants.Final.WSA_NAMESPACE:addressingSpec;
			OMElement omRef = EndpointReferenceHelper.toOM(new OMLinkedListImplFactory(), epr, new QName(add,"EndpointReference"), add);
			Element elemRef = XMLUtils.toDOM(omRef);
			ObjectFactory objFactory = new ObjectFactory();
			res = objFactory.createServiceRefType();
			res.setAny(elemRef);
		}
		return res;
	}
	
}
