package org.oasis.wscaf.newcore.types.wscf.impl;

import java.net.URI;
import java.util.ArrayList;

import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMFactory;
import org.apache.axis2.addressing.EndpointReference;
import org.oasis.wscaf.newcore.types.common.exceptions.MalformedElement;
import org.oasis.wscaf.newcore.types.wscf.RegistrationContext;
import org.oasis.wscaf.newcore.types.wsctx.impl.OMContext;

public class OMRegistrationContext extends OMContext implements
		RegistrationContext {

	private ArrayList extensions;//OMElement
	private ArrayList participants;//ParticipantGroup
	private ArrayList subProtocols;//URI
	private EndpointReference registrationService;
	
	public OMRegistrationContext(URI contextIdentifier) {
		super(contextIdentifier);
	}

	public ArrayList getExtensions() {
		return extensions;
	}

	public ArrayList getParticipants() {
		return participants;
	}

	public EndpointReference getRegistrationService() {
		return registrationService;
	}

	public ArrayList getSubProtocols() {
		return subProtocols;
	}

	public void setExtensions(ArrayList extensions) {
		this.extensions = extensions;
	}

	public void setParticipants(ArrayList participants) {
		this.participants = participants;
	}

	public void setRegistrationService(EndpointReference regService) {
		this.registrationService = regService;
	}

	public void setSubProtocols(ArrayList subProtocols) {
		this.subProtocols = subProtocols;
	}

	public void fromOM(OMElement element) throws MalformedElement {
		super.fromOM(element);
		
		ArrayList regList = (ArrayList) super.augmenters.get(RegistrationContext.REGISTRATION_SERVICE_NAME);
		if (regList != null) {
			OMElement regElement = (OMElement) regList.get(0);
			
		}
		
	}

	public OMElement toOM(OMFactory factory) {
		// TODO Auto-generated method stub
		return super.toOM(factory);
	}
	
	

}
