package org.oasis.wscaf.newcore.types.wsctx.impl;

import java.net.URI;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Set;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.apache.axiom.om.OMElement;
import org.apache.axiom.om.OMFactory;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.xmlbeans.XmlCursor;
import org.apache.xmlbeans.XmlException;
import org.apache.xmlbeans.XmlObject;
import org.oasis.wscaf.newcore.types.common.exceptions.MalformedElement;
import org.oasis.wscaf.newcore.types.wsctx.Context;
import org.oasis.wscaf.types.wsctx.ContextDocument;
import org.oasis.wscaf.utils.ConversionUtils;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class XBeanContext implements Context {
	
	protected ContextDocument context = ContextDocument.Factory.newInstance();
	protected HashMap augmenters = new HashMap();

	public XBeanContext(URI contextIdentifier) {
		this.context = ContextDocument.Factory.newInstance();
		context.addNewContext().addNewContextIdentifier().setStringValue(contextIdentifier.toString());
	}
	
	public void addAugmenter(OMElement augmenter) {
		try {
			XmlObject xbeanAugmenter = XmlObject.Factory.parse(augmenter.getXMLStreamReader());
			
			XmlCursor contextCursor = context.newCursor();
			contextCursor.toEndToken();
			contextCursor.beginElement(augmenter.getQName());
			
			XmlCursor augmenterCursor = xbeanAugmenter.newCursor();
			augmenterCursor.toFirstContentToken();
			augmenterCursor.copyXml(contextCursor);
			
		} catch (XmlException e) {
			System.out.println("Cannot parse augmenter to xmlbean");
			e.printStackTrace();
		}
	}

	public ArrayList getAugmenter(QName name) {
		XmlObject[] augmenters = context.execQuery("/"+this.getName().getNamespaceURI()+":"+this.getName().getLocalPart()+"/"+name.getNamespaceURI()+":"+name.getLocalPart());
		ArrayList result = new ArrayList();
		for (int i=0;i<augmenters.length;i++) {
			try {
				result.add(ConversionUtils.xBeanToOM(augmenters[i]));
			} catch (XMLStreamException e) {
				System.out.println("Error converting "
						+ augmenters[i].toString() + " to OMElement");
				e.printStackTrace();
				return null;
			}
		}
		return result;
	}

	public Set getAugmenters() {
		
		return null;
	}

	public EndpointReference getContextManager() {
		// TODO Auto-generated method stub
		return null;
	}

	public EndpointReference getContextService() {
		// TODO Auto-generated method stub
		return null;
	}

	public URI getIdentifier() {
		// TODO Auto-generated method stub
		return null;
	}

	public Context getParentContext() {
		// TODO Auto-generated method stub
		return null;
	}

	public void removeAugmenter(QName augmenter) {
		// TODO Auto-generated method stub

	}

	public void setContextManager(EndpointReference manager) {
		// TODO Auto-generated method stub

	}

	public void setContextService(EndpointReference service) {
		// TODO Auto-generated method stub

	}

	public void setIdentifier(URI identifier) {
		// TODO Auto-generated method stub

	}

	public void setParentContext(Context parentContext) {
		// TODO Auto-generated method stub

	}

	public void fromOM(OMElement element) throws MalformedElement {
		// TODO Auto-generated method stub

	}

	public QName getName() {
		// TODO Auto-generated method stub
		return null;
	}

	public OMElement toOM(OMFactory factory) {
		// TODO Auto-generated method stub
		return null;
	}

}
