/**
  * JASS Project. WS-CAF.
  *
  * Copyright (c) 2006, Distributed Systems Lab, Universidad Politecnica 
  * de Madrid (Spain)
  * All rights reserved.
  * Contact:
  *        web page: http://lsd.ls.fi.upm.es/lsd
  *        e-mail: mpatino@fi.upm.es or rjimenez@fi.upm.es
  *
  * Redistribution and use in source and binary forms, with or without 
  * modification, are permitted provided that the following conditions are met:
  *
  *    - Redistributions of source code must retain the above copyright 
  *      notice, this list of conditions and the following disclaimer.
  *    - Redistributions in binary form must reproduce the above copyright 
  *      notice, this list of conditions and the following disclaimer in the 
  *      documentation and/or other materials provided with the distribution.
  *    - Neither the name of the Distributed Systems Lab nor the names of 
  *      its contributors may be used to endorse or promote products derived from 
  *      this software without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
  * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
  * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
  * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
  * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, *
  * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
  * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
  * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  * 
  * Contributors: 
  * Francisco Pérez-Sorrosal (fpsorrosal@zipi.fi.upm.es)
  * Rubén Naranjo Izquierdo (rnaranjo@alumnos.upm.es)
  * José Antonio Sánchez Murillo (jsanchez@alumnos.upm.es)
  * 
  **/

package org.oasis.wscaf.utils;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;

import javax.xml.namespace.QName;
import javax.xml.stream.XMLStreamException;

import org.apache.axis2.AxisFault;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.xmlbeans.XmlCursor;
import org.apache.xmlbeans.XmlException;
import org.apache.xmlbeans.XmlObject;
import org.oasis.wscaf.core.wscf.exceptions.DuplicateParticipant;
import org.oasis.wscaf.core.wscf.types.Participant;
import org.oasis.wscaf.core.wscf.types.ParticipantGroup;
import org.oasis.wscaf.core.wscf.types.RegistrationContext;
import org.oasis.wscaf.core.wsctx.types.Context;
import org.oasis.wscaf.core.wsctx.types.ContextIdentifier;
import org.oasis.wscaf.types.reference.ServiceRefType;
import org.oasis.wscaf.types.wscf.ExtensionType;
import org.oasis.wscaf.types.wscf.ParticipantGroupType;
import org.oasis.wscaf.types.wscf.RegistrationContextType;
import org.oasis.wscaf.types.wsctx.ContextContainerType;
import org.oasis.wscaf.types.wsctx.ContextIdentifierType;
import org.oasis.wscaf.types.wsctx.ContextType;
import org.oasis.wscaf.types.wslra.LRAContextType;
import org.oasis.wscaf.utils.exceptions.AddressingNotSupported;
import org.w3c.dom.Node;

public abstract class SOAPUtils {
	
	/*public static OMElement getOMContext(SOAPHeader header, QName contextName) throws InvalidContextStructure {
		if (header==null) {
        	//System.out.println("[SOAPUtils][getContextFromHeader] No Headers found");
            return null;
        }
        
        OMElement omContext = ContextUtils.getContext(contextName);
        if(omContext==null) {
            //System.out.println("[SOAPUtils][getContextFromHeader] No context element found in header");
        	return null;
        }

        OMElement omId = ContextUtils.getContextElement(omContext,Constants.CONTEXT_IDENTIFIER_NAME);
        if (omId==null)
            throw new InvalidContextStructure("Provided context doesn't have a "+Constants.CONTEXT_IDENTIFIER_NAME+" element");
        
        return omContext;
	}

    public static Context getContextFromHeader(SOAPHeader header) throws AxisFault {
        //System.out.println("[SOAPUtils][Context] Header: " + header.toString());
        OMElement omContext = getOMContext(header, Constants.CONTEXT_NAME);
        if (omContext != null) {
        	Context context = null;
        	try {
        		ContextDocument xbeanContext = ContextDocument.Factory.parse(omContext.getXMLStreamReader());
        		context = translateContext(xbeanContext.getContext(), null);
        	} catch (Exception e) {
        		e.printStackTrace();
        		throw new InvalidContextStructure("Error while processing context: "+e.getMessage());
        	}    
        	return context;
        }
        return null;
    }

    public static RegistrationContext getRegistrationContextFromHeader(SOAPHeader header) throws AxisFault {
    	OMElement omContext = getOMContext(header, Constants.REGISTRATION_CONTEXT_NAME);
        if (omContext != null) {
        	RegistrationContext context = null;
        	try {
        		RegistrationContextDocument xbeanContext = RegistrationContextDocument.Factory.parse(omContext.getXMLStreamReader());
        		Context basicContext = translateContext(xbeanContext.getRegistrationContext(), null);
        		context = RegistrationContext.augmentToRegistrationContext(basicContext);
        	} catch (Exception e) {
        		e.printStackTrace();
        		throw new InvalidContextStructure("Error while processing registration context: "+e.getMessage());
        	}
        	return context;
        }
        return null;
    }*/
    
    /*public static EPR getReplyAddressFromHeader(SOAPHeader header) {
        //System.out.println("[SOAPUtils][Reply] Header: " + header.toString());
        if (header==null)
            return null;

        OMElement omSender = header.getFirstChildWithName(new QName(Constants.CONTEXT_NS, "replyTo"));
        if (omSender==null)
            return null;
        
        OMElement omEPR = omSender.getFirstChildWithName(new QName(Constants.ADDRESSING_NS, Constants.EPR_NAME));
        if (omEPR==null)
            return null;
        
        OMElement omAddress = omEPR.getFirstChildWithName(new QName(Constants.ADDRESSING_NS, Constants.ADDRESS_NAME));
        if (omAddress==null)
            return null;
        
        OMElement omPortType = omEPR.getFirstChildWithName(new QName(Constants.ADDRESSING_NS, Constants.PORTTYPE_NAME));
        if (omPortType==null)
            return null;
        
        String address  = omAddress.getText();
        String portType = omPortType.getText();
        
        EPR epr = new EPR(address, portType);
        //System.out.println("[SOAPUtils][Reply] ReplyTo EPR: \"" + epr.toString() + "\"");
        return epr;
    }*/

    public static ContextType translateContext(Context context) throws AxisFault, XmlException {
        ContextType newContext;
        if (context==null || context instanceof RegistrationContext) 
            newContext = RegistrationContextType.Factory.newInstance();
        else
            newContext = ContextType.Factory.newInstance();

        /** Basic Context Treatment **/
        ContextIdentifier contextIdentifier = null;
        EndpointReference  contextService    = null;
        EndpointReference  contextManager    = null;
        ContextIdentifier parentContext     = null;
        Calendar          expiresAt         = null;
        String            id                = null;
        //String            type              = null;
        ArrayList         augmenters        = null;

        if (context!=null) {
            contextIdentifier = context.getContextIdentifier();
            contextService    = context.getContextService();
            contextManager    = context.getContextManager();
            parentContext     = context.getParentContext();
            expiresAt         = context.getExpiresAt();
            id                = context.getId();
            //type              = context.getType().toString();
            augmenters        = context.getAugmenters();
        }

        if (contextService!=null) {
            //ServiceRefType newContextService = newContext.addNewContextService();
            //writeEPR(newContextService, contextService);
        	ServiceRefType newContextService = AddressingUtils.eprToServiceRef(contextService);
        	newContext.setContextService(newContextService);
        }

        if (contextManager!=null) {
            //ServiceRefType newContextManager = newContext.addNewContextManager();
            //writeEPR(newContextManager, contextManager);
        	ServiceRefType newContextManager = AddressingUtils.eprToServiceRef(contextManager);
        	newContext.setContextManager(newContextManager);
        }

        if (expiresAt!=null)
            newContext.setExpiresAt(expiresAt);

        if (id!=null)
            newContext.setId(id);

        if (parentContext!=null) {
            ContextContainerType parentContextContainer = newContext.addNewParentContext();
            ContextType newParentContext = ContextType.Factory.newInstance();
            ContextIdentifierType parentIdentifier = ContextIdentifierType.Factory.newInstance();
            parentIdentifier.setStringValue(parentContext.toString());
            newParentContext.setContextIdentifier(parentIdentifier);
            parentContextContainer.setContext(newParentContext);
        }

        if (contextIdentifier!=null) {
            ContextIdentifierType newContextIdentifier = ContextIdentifierType.Factory.newInstance();
            newContextIdentifier.setStringValue(contextIdentifier.toString());
            newContext.setContextIdentifier(newContextIdentifier);
        }
        else
            newContext.setNil();

        if (augmenters!=null && augmenters.size()>0) {
            XmlCursor cursor = newContext.newCursor();
            cursor.toFirstContentToken();
            for (int i=0; i<augmenters.size(); i++) {
                XmlCursor contentCursor = ((XmlObject)augmenters.get(i)).newCursor();
                contentCursor.copyXml(cursor);
                cursor.toNextToken();
            }
        }
        /*****************************/

        /** Registration Context Treatment **/
        if (context!=null && 
            context instanceof RegistrationContext) {
        	System.out.println("Es un registration context");
            RegistrationContext registrationContext = (RegistrationContext)context;
            RegistrationContextType newRegistrationContext = (RegistrationContextType)newContext;
            
            EndpointReference registrationService  = registrationContext.getRegistrationService();
            String[]         subProtocols         = registrationContext.getSubProtocols();
            Iterator         participantProtocols = registrationContext.getParticipantsProtocols();
            Object           extension            = registrationContext.getExtension();

            //ServiceRefType newRegistrationService = ServiceRefType.Factory.newInstance();
            ServiceRefType newRegistrationService;
            if (registrationService!=null) {
            	newRegistrationService = AddressingUtils.eprToServiceRef(registrationService);
            	System.out.println("Añadiendo registration service:\n"
						+ registrationService.toString());
                //writeEPR(newRegistrationService, registrationService);
            }
            else {
            	newRegistrationService = ServiceRefType.Factory.newInstance();
                newRegistrationService.setNil();
            }
            newRegistrationContext.setRegistrationService(newRegistrationService);

            if(subProtocols!=null)
                for (int i=0; i<subProtocols.length; i++) {
                    newRegistrationContext.addSubProtocol(subProtocols[i]);
                    System.out.println("Añadiendo subprotocol: "
							+ subProtocols[i]);
                }
            else
            	System.out.println("Subprotocols = null");

            while (participantProtocols.hasNext()) {
                ParticipantGroupType newParticipantGroup = newRegistrationContext.addNewParticipants();
                String protocol[] = new String[1];
                protocol[0] = (String)participantProtocols.next();
                newParticipantGroup.addProtocol(protocol[0]);
                ParticipantGroup group = registrationContext.getParticipants(protocol);
                ServiceRefType[] participants = new ServiceRefType[group.getParticipantsSize()];
                for(int i=0; i<group.getParticipantsSize(); i++) {
                    EndpointReference participant = group.getParticipant(i).getEndPoint();
                    //ServiceRefType newParticipant = newParticipantGroup.addNewParticipant();
                    participants[i] = AddressingUtils.eprToServiceRef(participant);
                    //writeEPR(newParticipant, participant);
                }
                newParticipantGroup.setParticipantArray(participants);
            }
            
            if (extension!=null) {
                ExtensionType newExtension = ExtensionType.Factory.newInstance();
                newExtension.set((XmlObject)extension);
                newRegistrationContext.setExtension(newExtension);
            }
        }
        /************************************/
        
        //System.out.println("[SOAPUtils][TranslateContext] From CoreContext to XMLContext:");
        //System.out.println(newContext);
        return newContext;
    }
    
    public static ContextType translateContextRef(Context context) throws AxisFault, XmlException {
    	ContextType res = ContextType.Factory.newInstance();
    	ContextIdentifierType cid = ContextIdentifierType.Factory.newInstance();
    	cid.setStringValue(context.getContextIdentifier().toString());
    	res.setContextIdentifier(cid);
    	res.setContextManager(AddressingUtils.eprToServiceRef(context.getContextManager()));
    	return res;
    }
    
    public static LRAContextType translateLRAContext(RegistrationContext context) throws AxisFault, XmlException {
        LRAContextType lraContext = LRAContextType.Factory.newInstance();
        XmlCursor lraCursor = lraContext.newCursor();
        XmlCursor cursor = translateContext(context).newCursor();
        lraCursor.toFirstContentToken();
        cursor.copyXmlContents(lraCursor);
        lraContext.setLraId(context.getContextIdentifier().toString());
        //System.out.println("[SOAPUtils][TranslateLRAContext] Copied context: " + lraContext);

        /*CoordinatorHierarchy coordinatorHierarchy = CoordinatorHierarchy.Factory.newInstance();
        coordinatorHierarchy.addCoordinatorLocation(Constants.COORDINATOR_SERVICE_EPR);
        lraContext.setCoordinatorHierarchy(coordinatorHierarchy);*/
        
        return lraContext;
    }

    /*public static OMNode translateEPR(EPR epr, OMFactory omFactory) {
        //OMDOMFactory omFactory = new OMDOMFactory();

        OMNamespace contextNamespace = omFactory.createOMNamespace(Constants.CONTEXT_NS, "ctx");
        OMNamespace addressingNamespace = omFactory.createOMNamespace(Constants.ADDRESSING_NS, "add");

        OMElement senderNode = omFactory.createOMElement("replyTo", contextNamespace);
        senderNode.declareDefaultNamespace(Constants.CONTEXT_NS);
        senderNode.declareNamespace(addressingNamespace);
        OMAttribute referenceScheme = omFactory.createOMAttribute("reference-scheme", contextNamespace, Constants.ADDRESSING_NS);
        senderNode.addAttribute(referenceScheme);

        OMElement endpointNode = omFactory.createOMElement(Constants.EPR_NAME, addressingNamespace, senderNode);

        OMElement addressNode = omFactory.createOMElement(Constants.ADDRESS_NAME, addressingNamespace, endpointNode);
        addressNode.setText(epr.getAddress());
        OMElement portTypeNode = omFactory.createOMElement(Constants.PORTTYPE_NAME, addressingNamespace, endpointNode);
        portTypeNode.setText(epr.getPortType());

        return senderNode;
    }*/

    /*public static OMNode translateContext(ContextType context) {
        OMDOMFactory omFactory = new OMDOMFactory();

        OMNamespace contextNamespace = omFactory.createOMNamespace(Constants.CONTEXT_NS, "ctx");
        OMNamespace soapNamespace = omFactory.createOMNamespace(Constants.SOAP_NS, "soap");

        OMElement contextNode = omFactory.createOMElement("context", contextNamespace);
        contextNode.declareDefaultNamespace(Constants.CONTEXT_NS);
        OMAttribute mustUnderstand = omFactory.createOMAttribute("mustUnderstand", soapNamespace, "1");
        contextNode.addAttribute(mustUnderstand);

        OMElement identifierNode = omFactory.createOMElement("context-identifier", contextNamespace, contextNode);
        if (context!=null && !context.isNil()) {
            identifierNode.setText(context.getContextIdentifier().getStringValue());
            
            ContextContainerType parentContext = context.getParentContext();
            if (parentContext!=null &&
                parentContext.getContext()!=null &&
                parentContext.getContext().getContextIdentifier()!=null &&
                parentContext.getContext().getContextIdentifier().getStringValue()!=null) {
                String parentId = parentContext.getContext().getContextIdentifier().getStringValue();
                OMElement parentContainerNode = omFactory.createOMElement("parent-context", contextNamespace, contextNode);
                OMElement parentContextNode = omFactory.createOMElement("context", contextNamespace, parentContainerNode);
                OMElement parentIdentifierNode = omFactory.createOMElement("context-identifier", contextNamespace, parentContextNode);
                parentIdentifierNode.setText(parentId);
            }
        }

        return contextNode;
    }*/
    
    
    
    /*public static OMNode translateFault(CAFFault fault) throws AxisFault {
        return translateFault(fault, true);
    }
    
    public static OMElement translateFault(CAFFault fault, boolean mustUnderstand) throws AxisFault {
        OMDOMFactory omFactory = new OMDOMFactory();

        OMNamespace contextNamespace = omFactory.createOMNamespace(Constants.CONTEXT_NS, "ctx");
        OMNamespace addressingNamespace = omFactory.createOMNamespace(AddressingConstants.Final.WSA_NAMESPACE, "wsa");
        OMNamespace soapNamespace = omFactory.createOMNamespace(Constants.SOAP_NS, "soap");

        OMElement faultNode = omFactory.createOMElement("fault", soapNamespace);
        faultNode.declareDefaultNamespace(Constants.CONTEXT_NS);
        if (mustUnderstand) {
            OMAttribute mustUnderstandAtt = omFactory.createOMAttribute("mustUnderstand", soapNamespace, "1");
            faultNode.addAttribute(mustUnderstandAtt);
        }

        OMElement faultCodeNode = omFactory.createOMElement("faultcode", soapNamespace, faultNode);
        faultCodeNode.setText(fault.getFaultCode());
        
        OMElement faultStringNode = omFactory.createOMElement("faultstring", soapNamespace, faultNode);
        faultStringNode.setText(fault.getMessage());

        if (fault instanceof TimeoutNotSupported) {
            TimeoutNotSupported timeoutFault = (TimeoutNotSupported)fault;
            OMElement faultDetailNode = omFactory.createOMElement("detail", soapNamespace, faultNode);
            faultDetailNode.declareDefaultNamespace(Constants.CONTEXT_NS);
            
            OMElement specifiedTimeoutNode = omFactory.createOMElement("specified-timeout", contextNamespace, faultDetailNode);
            specifiedTimeoutNode.setText(Integer.toString(timeoutFault.getSpecifiedTimeout()));
            
            OMElement maximumTimeoutNode = omFactory.createOMElement("maximum-timeout", contextNamespace, faultDetailNode);
            maximumTimeoutNode.setText(Integer.toString(timeoutFault.getMaximunTimeout()));
        }
        else if (fault instanceof UnknownContext) {
            UnknownContext contextFault = (UnknownContext)fault;
            OMElement faultDetailNode = omFactory.createOMElement("detail", soapNamespace, faultNode);
            faultDetailNode.declareDefaultNamespace(Constants.CONTEXT_NS);
            
            OMElement contextIdNode = omFactory.createOMElement("context-identifier", contextNamespace, faultDetailNode);
            contextIdNode.setText(contextFault.getUnknownContextId().toString());
        }
        else if (fault instanceof DuplicateParticipant) {
            DuplicateParticipant duplicateFault = (DuplicateParticipant)fault;
            OMElement faultDetailNode = omFactory.createOMElement("detail", soapNamespace, faultNode);
            faultDetailNode.declareDefaultNamespace(Constants.CONTEXT_NS);
            
            OMElement participantNode = EndpointReferenceHelper.toOM(omFactory, 
            														 duplicateFault.getDuplicateParticipant(), 
            														 new QName(contextNamespace.getNamespaceURI(),
            																   "duplicate-participant",
            																   contextNamespace.getPrefix()), 
            													     AddressingConstants.Final.WSA_NAMESPACE);
            faultDetailNode.addChild(participantNode);
            
        }
        else if (fault instanceof InvalidProtocol) {
            InvalidProtocol invalidFault = (InvalidProtocol)fault;
            OMElement faultDetailNode = omFactory.createOMElement("detail", soapNamespace, faultNode);
            faultDetailNode.declareDefaultNamespace(Constants.CONTEXT_NS);
            
            OMElement protocolNode = omFactory.createOMElement("protocol", contextNamespace, faultDetailNode);
            protocolNode.setText(invalidFault.getProtocol());
        }
        else if (fault instanceof ParticipantNotFound) {
            ParticipantNotFound notFoundFault = (ParticipantNotFound)fault;
            OMElement faultDetailNode = omFactory.createOMElement("detail", soapNamespace, faultNode);
            faultDetailNode.declareDefaultNamespace(Constants.CONTEXT_NS);
            
            OMElement participantNode = EndpointReferenceHelper.toOM(omFactory, 
            														 notFoundFault.getRequestedParticipant().getEndPoint(), 
            														 new QName(contextNamespace.getNamespaceURI(),
            																   "requestedParticipant",
            																   contextNamespace.getPrefix()), 
            														 AddressingConstants.Final.WSA_NAMESPACE);
            faultDetailNode.addChild(participantNode);
        }

        //System.out.println("[SOAPUtils][TranslateFault] Fault: " + faultNode.toString());
        return faultNode;
    }

    public static void translateFault(CAFFault fault, XmlCursor cursor) {
        cursor.toFirstContentToken();
        
        cursor.beginElement(new QName(Constants.SOAP_NS, "faultcode"));
        cursor.insertChars(fault.getFaultCode());
        cursor.toNextToken();
        
        cursor.beginElement(new QName(Constants.SOAP_NS, "faultstring"));
        cursor.insertChars(fault.getMessage());
        cursor.toNextToken();
        
        if (fault instanceof TimeoutNotSupported) {
            TimeoutNotSupported timeoutFault = (TimeoutNotSupported)fault;
            cursor.beginElement(new QName(Constants.SOAP_NS, "detail"));
            
            cursor.beginElement(new QName(Constants.CONTEXT_NS, "specified-timeout"));
            cursor.insertChars(Integer.toString(timeoutFault.getSpecifiedTimeout()));
            cursor.toNextToken();
            
            cursor.beginElement(new QName(Constants.CONTEXT_NS, "maximum-timeout"));
            cursor.insertChars(Integer.toString(timeoutFault.getMaximunTimeout()));
        }
        else if (fault instanceof UnknownContext) {
            UnknownContext contextFault = (UnknownContext)fault;
            cursor.beginElement(new QName(Constants.SOAP_NS, "detail"));
            
            cursor.beginElement(new QName(Constants.CONTEXT_NS, "context-identifier"));
            cursor.insertChars(contextFault.getUnknownContextId().toString());
        }
    }

    public static CAFFault getFaultFromHeader(SOAPHeader header) {
        //System.out.println("[SOAPUtils][Context] Header: " + header.toString());
        if (header==null)
            return null;
        
        OMElement omFault = header.getFirstChildWithName(new QName(Constants.SOAP_NS, "fault"));
        if(omFault==null)
            return null;

        OMElement omCode = omFault.getFirstChildWithName(new QName(Constants.SOAP_NS, "faultcode"));
        if (omCode==null)
            return null;

        OMElement omCause = omFault.getFirstChildWithName(new QName(Constants.SOAP_NS, "faultstring"));
        if (omCause==null)
            return null;
        
        String code  =  omCode.getText();
        String cause = omCause.getText();
        
        CAFFault fault = CAFFault.createFault(code, cause);
        if (fault==null)
            return null;
        
        OMElement omDetail = omFault.getFirstChildWithName(new QName(Constants.SOAP_NS, "detail"));
        if (omDetail!=null && fault instanceof TimeoutNotSupported) {
            TimeoutNotSupported timeoutFault = (TimeoutNotSupported)fault;
            
            OMElement omSpecifiedTimeout = omDetail.getFirstChildWithName(new QName(Constants.CONTEXT_NS, "specified-timeout"));
            if (omSpecifiedTimeout!=null)
                timeoutFault.setSpecifiedTimeout(Integer.parseInt(omSpecifiedTimeout.getText()));
            
            OMElement omMaximumTimeout = omDetail.getFirstChildWithName(new QName(Constants.CONTEXT_NS, "maximum-timeout"));
            if (omMaximumTimeout!=null)
                timeoutFault.setSpecifiedTimeout(Integer.parseInt(omMaximumTimeout.getText()));
        }
        
        if (omDetail!=null && fault instanceof UnknownContext) {
            UnknownContext contextFault = (UnknownContext)fault;
            
            OMElement omId = omDetail.getFirstChildWithName(new QName(Constants.CONTEXT_NS, "context-identifier"));
            if (omId!=null)
                contextFault.setUnknownContextId(new ContextIdentifier(omId.getText()));
        }

        //System.out.println("[SOAPUtils][GetFault] Fault: " + fault.toString());
        return fault;
    }*/

    public static Context translateContext(ContextType context, EndpointReference replyTo) throws XMLStreamException, XmlException, AxisFault, AddressingNotSupported {
        if (context==null) 
            return null;

        ContextIdentifierType contextIdentifier = context.getContextIdentifier();
        ServiceRefType        contextService    = context.getContextService();
        ServiceRefType        contextManager    = context.getContextManager();
        ContextContainerType  parentContext     = context.getParentContext();
        Calendar              expiresAt         = context.getExpiresAt();
        String                id                = context.getId();
        //type              = context.getType().toString();
        XmlObject[] anys                        = context.selectChildren(ContextType.type.qnameSetForWildcardElements());
        //anys = newContext.selectChildren(QNameSet.forWildcardNamespaceString("##other", ""));
        //anys = newContext.selectChildren(QNameSet.forWildcardNamespaceString("##other", "http://docs.oasis-open.org/schemas/2005/10/wsctx"));
        //anys = newContext.selectChildren(QNameSet.forWildcardNamespaceString("##any", ""));
        //anys = newContext.selectChildren(QNameSet.forWildcardNamespaceString("##any", "http://docs.oasis-open.org/schemas/2005/10/wsctx"));

        System.out.println("[SOAPUtils][translateContext]Translating context:\n" + context.toString());
        System.out
				.println("-----------------------------------------------------------------------");
        
        Context newContext = new Context();
        
        if (contextIdentifier!=null) {
            newContext.setContextIdentifier(new ContextIdentifier(contextIdentifier.getStringValue()));
            System.out.println("contextIdentifier:\n" + contextIdentifier.toString());
        }
        
        if (parentContext!=null && parentContext.getContext()!=null && parentContext.getContext().getContextIdentifier()!=null) {
            newContext.setParentContext(new ContextIdentifier(parentContext.getContext().getContextIdentifier().getStringValue()));
            System.out.println("parentContext:\n" + parentContext.toString());
        }
        
        if(expiresAt!=null) {
            newContext.setExpiresAt(expiresAt);
            System.out.println("expiresAt:\n" + expiresAt.toString());
        }
        
        if (id!=null) {
            newContext.setId(id);
            System.out.println("id: " + id);
        }
        
        if (contextService != null) {
        	newContext.setContextService(AddressingUtils.serviceRefToEPR(contextService));
        	System.out.println("contextService:\n" + contextService.toString());
        }
        
        if (contextManager != null) {
        	newContext.setContextManager(AddressingUtils.serviceRefToEPR(contextManager));
        	System.out.println("contextManager:\n" + contextManager.toString());
        }

        boolean augmented = false;
        for (int i=0; i<anys.length; i++) {
        	
        	System.out.println("Processing any:\n" + anys[i].toString());
            
        	Node node = anys[i].getDomNode();
        	System.out.println("Node local name: " + node.getLocalName());
        	System.out
					.println("Node namespace: " + node.getNamespaceURI());
            if (node.getNamespaceURI().equalsIgnoreCase(Constants.COORDINATION_NS)) {
                if(node.getLocalName().equals("registration-service")) {
                    if (!augmented) {
                        newContext = RegistrationContext.augmentToRegistrationContext(newContext);
                        augmented = true;
                    }
                    EndpointReference registrationService = AddressingUtils.xBeanToEPR(anys[i]);
                    ((RegistrationContext)newContext).setRegistrationService(registrationService);
                }
                else if (node.getLocalName().equals("sub-protocol")) {
                    if (!augmented) {
                        newContext = RegistrationContext.augmentToRegistrationContext(newContext);
                        augmented = true;
                    }
                    ((RegistrationContext)newContext).addSubProtocol(anys[i].newCursor().getTextValue());
                }
                else if (node.getLocalName().equals("participants")) {
                    if (!augmented) {
                        newContext = RegistrationContext.augmentToRegistrationContext(newContext);
                        augmented = true;
                    }
                    ArrayList protocols = new ArrayList();
                    ArrayList participants = new ArrayList();
                    
                    XmlCursor cursor = anys[i].newCursor();
                    boolean state = cursor.toFirstChild();
                    while(state) {
                        if (cursor.getName().getLocalPart().equals("protocol"))
                            protocols.add(cursor.getTextValue());
                        else if (cursor.getName().getLocalPart().equals("participant")) {
                            EndpointReference epr = AddressingUtils.xBeanToEPR(anys[i]);
                            if (epr!=null)
                                participants.add(epr);
                        }
                        state = cursor.toNextSibling();
                    }
                    String[] protocolArray = (String[])protocols.toArray(new String[0]);
                    for (int j=0; j<participants.size(); j++) {
                        try {
                            ((RegistrationContext)newContext).addParticipant(new Participant((EndpointReference)participants.get(j)), protocolArray);
                        } catch (DuplicateParticipant e) {}
                    }
                }
                else if (node.getLocalName().equals("extension")) {
                    if (!augmented) {
                        newContext = RegistrationContext.augmentToRegistrationContext(newContext);
                        augmented = true;
                    }
                    if (!anys[i].isNil())
                        ((RegistrationContext)newContext).setExtension(anys[i]);
                }            
                else
                    newContext.addAugmenter(anys[i]);
            }
            else
                newContext.addAugmenter(anys[i]);
            //System.out.println("Any #" + i + ": \"" + anys[i].getDomNode().getLocalName() + "\"");
        }

        System.out.println("[SOAPUtils][TranslateContext] From XMLContext to CoreContext:");
        newContext.printContents("[SOAPUtils][TranslateContext] ");
        
        return newContext;
    }
    
    
    
    /*private static void writeEPR(XmlCursor cursor, String address, String portType) {
        cursor.toFirstContentToken();
        cursor.beginElement(new QName(Constants.ADDRESSING_NS, Constants.EPR_NAME));
        cursor.beginElement(new QName(Constants.ADDRESSING_NS, Constants.ADDRESS_NAME));
        cursor.insertChars(address);
        cursor.toNextToken();
        cursor.beginElement(new QName(Constants.ADDRESSING_NS, Constants.PORTTYPE_NAME));
        cursor.insertChars(portType);
        cursor.toNextToken();
    }
    
    public static void writeEPR(ServiceRefType reference, ServiceReference epr) {
        reference.setReferenceScheme(Constants.ADDRESSING_NS);
        OMElement eprElement = EndpointReferenceHelper.toOM(new OMLinkedListImplFactory(), epr, new QName("xml-fragment"), Constants.ADDRESSING_NS);
        
        //writeEPR(reference.newCursor(), epr.getAddress(), epr.getPortType());
    }
    
    public static void writeEPR(ServiceRefType reference, String address, String portType) {
        reference.setReferenceScheme(Constants.ADDRESSING_NS);
        //writeEPR(reference.newCursor(), address, portType);
    }*/
    
    
    
    public static String getAnyElementValue(XmlObject object, String localName) {
        if (object==null)
            return null;
        
        XmlObject[] anys = object.selectChildren(ContextType.type.qnameSetForWildcardElements());
        
        if (anys==null || anys.length==0)
            return null;
        
        for (int i=0; i<anys.length; i++) {
            Node node = anys[i].getDomNode();
            if(node.getLocalName().equals(localName)) {
                return anys[i].newCursor().getTextValue();
            }
        }
        return null;
    }
    
    public static void setAnyElementValue(XmlObject object, String namespace, String localName, String value) {
        if (object==null)
            return;
        
        XmlCursor cursor = object.newCursor();
        cursor.toFirstContentToken();
        cursor.beginElement(new QName(namespace, localName));
        cursor.insertChars(value);
    }
    
    /*public static XmlObject toXmlObject(OMElement element) throws XmlException{
    	return  XmlObject.Factory.parse(element.toString());
    }*/

    public static XmlObject getAugmenter(Context context, QName name) {
    	ArrayList augmenters = context.getAugmenters();
		Iterator iterator = augmenters.iterator();
		while (iterator.hasNext()) {
			XmlObject augmenter = (XmlObject) iterator.next();
			Node augmenterNode = augmenter.getDomNode();
			if ((augmenterNode.getNamespaceURI().equals(name.getNamespaceURI())) &&
				(augmenterNode.getLocalName().equals(name.getLocalPart()))) {
				return augmenter;
			}
		}
		return null;
    }
	/*public static boolean compareMap(Map allReferenceParameters, Map allReferenceParameters2) {
		Iterator keyIterator = allReferenceParameters.keySet().iterator();
		if (allReferenceParameters.size() != allReferenceParameters2.size()) {
			return false;
		}
		while (keyIterator.hasNext()) {
			Object key = keyIterator.next();
			if (!(allReferenceParameters.get(key).equals(allReferenceParameters2.get(key)))) {
				return false;
			}
		}
		return true;
	}

	public static boolean compareArrayLists(ArrayList attributes, ArrayList attributes2) {
		int i = 0;
		if (attributes.size() != attributes2.size()) {
			return false;
		}
		for (i=0;i<attributes.size();i++) {
			if (!attributes2.contains(attributes.get(i))) {
				return false;
			}
		}
		return true;
	}*/


}
